import java.io.*;
import java.util.*;
import java.math.*;

public class decorator_aa {
	public static void main(String[] args) {
		new decorator_aa().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	int inBounds(int x, int l, int r, String name) {
		myAssert(l <= x && x <= r, name + " is not in bounds: " + x
				+ " not in [" + l + ", " + r + "]");
		return x;
	}

	String FNAME = "decorator";

	private void solve() throws IOException {
		int n = inBounds(nextInt(), 1, 100000, "n");
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = inBounds(nextInt(), 1, 100000, "a[" + (i + 1) + "]");
		}
		Tree t = new Tree(n);
		for (int i = 0; i < a.length; i++) {
			t.set(i, i, a[i]);
		}
		long[] inv = new long[n];
		long Y = BigInteger.valueOf(X)
				.modInverse(BigInteger.valueOf(2).pow(64)).longValue();
		inv[0] = 1;
		for (int i = 1; i < inv.length; i++) {
			inv[i] = inv[i - 1] * Y;
		}
		int m = inBounds(nextInt(), 1, 100000, "m");
		// long tset = 0;
		// long tget = 0;
		for (int req = 0; req < m; req++) {
			int q = inBounds(nextInt(), 0, 1, "q_" + (req + 1));
			if (q == 0) {
				int l = inBounds(nextInt(), 1, n, "l_" + (req + 1));
				int r = inBounds(nextInt(), l, n, "r_" + (req + 1));
				int k = inBounds(nextInt(), 1, 100000, "k_" + (req + 1));
				l--;
				r--;
				// long time = System.currentTimeMillis();
				t.set(l, r, k);
				// tset += (System.currentTimeMillis() - time);
			} else {
				int l = inBounds(nextInt(), 1, n, "l_" + (req + 1));
				int r = inBounds(nextInt(), 1, n, "r_" + (req + 1));
				int k = inBounds(nextInt(), 1, 100000, "k_" + (req + 1));
				myAssert(l + k - 1 <= n, "l_" + (req + 1) + " + k_" + (req + 1)
						+ " - 1 is too big!!! " + l + " + " + k + " - 1 > " + n);
				myAssert(r + k - 1 <= n, "r_" + (req + 1) + " + k_" + (req + 1)
						+ " - 1 is too big!!! " + r + " + " + k + " - 1 > " + n);
				l--;
				r--;
				// long time = System.currentTimeMillis();
				long hash1 = t.get(l, l + k - 1) * inv[l];
				long hash2 = t.get(r, r + k - 1) * inv[r];
				// tget += (System.currentTimeMillis() - time);
				if (hash1 == hash2) {
					out.print("+");
				} else {
					out.print("-");
				}
			}
		}
		// System.out.println(tset / 1000.0);
		// System.out.println(tget / 1000.0);
	}

	class Tree {
		public Tree(int n) {
			m = 1;
			while (m < n) {
				m *= 2;
			}
			q = new long[2 * m];
			a = new int[2 * m];
			s = new long[2 * m];
			s[m] = 1;
			for (int i = m + 1; i < s.length; i++) {
				s[i] = s[i - 1] * X;
			}
			for (int i = m - 1; i > 0; i--) {
				s[i] = s[2 * i] + s[2 * i + 1];
			}
		}

		public long get(int l, int r) {
			ans = 0;
			L = l;
			R = r;
			_get(1, 0, m - 1);
			return ans;
		}

		private void _get(int x, int l, int r) {
			if (R < l || r < L) {
				return;
			}
			if (L <= l && r <= R) {
				ans += q[x];
				return;
			}
			relax(x);
			_get(2 * x, l, (l + r) / 2);
			_get(2 * x + 1, (l + r + 2) / 2, r);
		}

		public void set(int l, int r, int value) {
			L = l;
			R = r;
			this.value = value;
			_set(1, 0, m - 1);
		}

		int L, R, value;
		long ans;

		private void _set(int x, int l, int r) {
			if (R < l || r < L) {
				return;
			}
			if (L <= l && r <= R) {
				a[x] = value;
				q[x] = s[x] * value;
				return;
			}
			relax(x);
			_set(2 * x, l, (l + r) / 2);
			_set(2 * x + 1, (l + r + 2) / 2, r);
			q[x] = q[2 * x] + q[2 * x + 1];
		}

		private void relax(int x) {
			int d = a[x];
			int j = 2 * x;
			if (d > 0 && j < a.length) {
				a[j] = d;
				q[j] = d * s[j];
				j++;
				a[j] = d;
				q[j] = d * s[j];
			}
			a[x] = 0;
		}

		long[] q;
		int[] a;
		long[] s;
		int m;

	}

	long X = BigInteger.valueOf(82641091724L).nextProbablePrime()
			.longValue();
}
